Attribute VB_Name = "modFiles"
Dim shellApp As Object, fSystem As Object

Sub browseSingle(path As String)
    'Browse a directory

    Dim folder As Object, dataFile As Object
    Set folder = fSystem.getfolder(path)

    Dim dataFiles As Object
    For Each dataFiles In folder.Files
        'Place here what to do with the file dataFile        
    Next
End Sub

Sub browse(path As String)
    'Browse a directory and its sub-directories

    Dim p As Object, folder As Object, dataFile As Object
    Set p = fSystem.getfolder(path)

    For Each folder In p.SubFolders
        For Each dataFile In folder.Files
	    'Place here what to do with the file dataFile
        Next
        Call Browse(folder)
    Next
End Sub

Function getDirectory(Msg As String) As String
  'Offer to choose a directory (like a CommonDialog)

  Dim tmp As Object, indx As Integer
  On Error Resume Next

  Set tmp = shellApp.BrowseForFolder(&H0&, Msg, &H1&)
  getDirectory = tmp.ParentFolder.ParseName(tmp.Title).Path

  If Err.Number <> 0 Then
    getDirectory = Null
    indx = InStr(tmp.Title, ":")
    If indx > 0 Then getDirectory = Mid(tmp.Title, indx - 1, 2) & "\"
  End If
End Function


Public Function getPath(path As String) As String
    'This function returns the directory of a file
    'Returns [@error] if can't get path

    Dim indx As Integer, end As Integer
    indx = -1
    While indx <> 0
        indx = InStr(end + 1, path, "\")
        If indx <> 0 Then end = indx
    Wend
    If end = 0 Then
        getPath = "[@error]"
        Exit Function
    End If
    getPath = Left(path, end - 1)
End Function

Public Function getFile(path As String) As String
    'This function just returns the filename of a full path
    'Returns [@error] if can't get name

    Dim indx As Integer, end As Integer
    indx = -1
    While indx <> 0
        indx = InStr(end + 1, path, "\")
        If indx <> 0 Then end = indx
    Wend
    If end = 0 Then
        getFile = "[@error]"
        Exit Function
    End If
    getFile = Right(path, Len(path) - end)
End Function

Public Function nicePath(Str As String) As String
    'Makes a path looking better

    Dim PrvChar As String, Char As String

    PrvChar = ""
    For i = 1 To Len(Str)
        Char = Mid$(Str, i, 1)
        If PrvChar = "" Or PrvChar = "\" Then
            NewChar = UCase$(Char)
            Str = Mid$(Str, 1, i - 1) & NewChar & Mid$(Str, i + 1, Len(Str))
        End If
        PrvChar = Char
    Next
    NicePath = Str
End Function
